/*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
LGSL Konfubaltor Widget
Written by [SCUT]Crapmaster
Version 1.0.1 - December 1, 2005
http://scut.se/
mailto:crapmaster@scut.se
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
*/

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Constants
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
var LGSL_ADDRESS_START  = "'>";
var LGSL_ADDRESS_STOP   = "</a></td>";
var LGSL_ENTRY_START    = "<td class='list_row'>";
var LGSL_ENTRY_STOP     = "</td>";
var LGSL_IMAGE_START    = "<img src='";
var LGSL_IMAGE_STOP     = "'";
var LGSL_NAME_START     = "'>";
var LGSL_NAME_STOP      = "</a></td>";
var LGSL_PLAYERS_START1 = "<td class='list_row'";
var LGSL_PLAYERS_START2 = "'>";
var LGSL_PLAYERS_STOP   = "</a></td>";

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Variables
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
var imagePath;
var lgslUrl;
var maxMapOffset;
var maxPlayersOffset;
var maxRowWidth;
var myUrl;
var serverItemWidgets;
var serverRowCount;
var textColor;
var widgetColor;
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

init();

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Init data used by script
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function init(){
  // Init variables
  maxMapOffset      = 0;
  maxPlayersOffset  = 0;
  maxRowWidth       = 0;
  myUrl             = new URL();
  serverItemWidgets = new Array();
  serverRowCount    = 0;
 
  // Get preferences
  imagePath   = preferences.lgsl_images_path.value;
  lgslUrl     = preferences.lgsl_url.value;
	widgetColor = preferences.widgetColor.value

  // Set update interval
  timer.interval = 60*preferences.updateinterval.value;
  if (timer.interval < 60) {
    // Set default value, 15 minutes
    timer.interaval = 15*60;
  }
  
  // Apply appearance settings
  applyWidgetAppearanceSettings();

  // Get LGSL index page
  var indexPage = myUrl.fetch(lgslUrl);
  if (indexPage != "") {
    buildServerList(indexPage);
  }

}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Update LGSL information
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function updateLGSL(){
  var indexPage = myUrl.fetch(lgslUrl);

  if (indexPage != "") {
    buildServerList(indexPage);
  }
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Apply changed preferences
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function applyPrefs(){
  // Get preferences
  var tmpImagePath     = preferences.lgsl_images_path.value;
  var tmplgslUrl       = preferences.lgsl_url.value;
  var tmpTimerInterval = preferences.updateinterval.value;
  var tmpWidgetColor   = preferences.widgetColor.value;

  if ( (tmplgslUrl != lgslUrl) || (tmpImagePath != imagePath) ) {  
    lgslUrl   = preferences.lgsl_url.value;
    imagePath = preferences.lgsl_images_path.value;

    updateLGSL();
    timer.reset();
  }

  if (tmpWidgetColor != widgetColor) {
    widgetColor= preferences.widgetColor.value
    applyWidgetAppearanceSettings();
  }
  
  if (tmpTimerInterval != timer.interval) {
    timer.interval = 60*preferences.updateinterval.value;
    if (timer.interval < 60) {
      timer.interaval = 15*60;
    }
    timer.reset();
  }
  
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Apply appearance settings
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function applyWidgetAppearanceSettings(){
  // Calculate textColor based on widgetColor
	if(parseInt(widgetColor.substr(1,2), 16) + parseInt(widgetColor.substr(3,2), 16) + parseInt(widgetColor.substr(5,2), 16) > 382) {
		textColor ="#000000";
	} else {
		textColor ="#ffffff";
	}

  // Set widgetColor
  title_left_background.colorize    = widgetColor;
  title_left_glass.colorize         = widgetColor;
  title_center_background.colorize  = widgetColor;
  title_center_glass.colorize       = widgetColor;
  title_right_background.colorize   = widgetColor;
  title_right_glass.colorize        = widgetColor;
  center_left_background.colorize   = widgetColor;
  center_left_glass.colorize        = widgetColor;
  center_center_background.colorize = widgetColor;
  center_center_glass.colorize      = widgetColor;
  center_right_background.colorize  = widgetColor;
  center_right_glass.colorize       = widgetColor;
  bottom_left_background.colorize   = widgetColor;
  bottom_left_glass.colorize        = widgetColor;
  bottom_center_background.colorize = widgetColor;
  bottom_center_glass.colorize      = widgetColor;
  bottom_right_background.colorize  = widgetColor;
  bottom_right_glass.colorize       = widgetColor;
  
  for(var i=0; i < serverItemWidgets.length ; i++){
    serverItemWidgets[i][2].color = textColor;
    serverItemWidgets[i][3].color = textColor;
    serverItemWidgets[i][4].color = textColor;
    serverItemWidgets[i][5].color = textColor;
  }
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Init data used by script
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function buildServerList(indexPage){
  var serverItems = getServerItemsFromLGSLPage(indexPage);

  lgsl.height = 50;

  // Now draw each stats row
  for(var i = 0; i < serverItems.length ; i++){
    serverItem = serverItems[i];
    if (serverItemWidgets[i]) {
      updateServerItemWidget(serverItem, i);
    } else {
      serverItemWidgets[i] = createServerItemWidget(serverItem);
    }
    serverRowCount++;
    lgsl.height += 18;
  }

  fixColumns();
  
  resize();
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Fix straight coloumns
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function fixColumns(){
  for(var i = 0; i < serverItemWidgets.length ; i++){
    serverItemWidgets[i][4].hOffset = maxMapOffset;
    
    var playersOffset = 10 + serverItemWidgets[i][4].hOffset + serverItemWidgets[i][4].width;
    if (playersOffset > maxPlayersOffset) {
      maxPlayersOffset = playersOffset;
    }
  }

  for(var i = 0; i < serverItemWidgets.length ; i++){
    serverItemWidgets[i][5].hOffset = maxPlayersOffset;
    
    var rowWidth = serverItemWidgets[i][5].hOffset + serverItemWidgets[i][5].width;
    if (rowWidth > maxRowWidth) {
      maxRowWidth = rowWidth;
    }
  }
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Fix image path
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function fixImagePath(imagePathToFix){
  var index = imagePathToFix.indexOf(imagePath, 0);

  if(index >= 0) {
    imagePathToFix = "images" + imagePathToFix.substring(index+imagePath.length);
  }

  return imagePathToFix;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-


//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Create widget
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function createServerItemWidget(serverItem){
	var serverItemWidget = new Array();
  var openSteamURL     = "openURL(\"steam://connect/" + serverItem.address + "\")";
  
  serverItemWidget[0]              = new Image();
	serverItemWidget[0].window       = lgsl;
	serverItemWidget[0].src          = "Resources/" + serverItem.status;
	serverItemWidget[0].opacity      = 255;
	serverItemWidget[0].vOffset      = 20 + serverRowCount*18;
	serverItemWidget[0].hOffset      = 25;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[0].onMultiClick = openSteamURL;
  }

  serverItemWidget[1]              = new Image();
	serverItemWidget[1].window       = lgsl;
	serverItemWidget[1].src          = "Resources/" + serverItem.game;
	serverItemWidget[1].opacity      = 255;
	serverItemWidget[1].vOffset      = 20 + serverRowCount*18;
	serverItemWidget[1].hOffset      = 45;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[1].onMultiClick = openSteamURL;
  }
  
  serverItemWidget[2]              = new Text();
	serverItemWidget[2].window       = lgsl;
	serverItemWidget[2].data         = serverItem.address;
  serverItemWidget[2].color        = textColor;
  serverItemWidget[2].style        = "bold";
	serverItemWidget[2].size         = 12;
	serverItemWidget[2].opacity      = 255;
	serverItemWidget[2].vOffset      = 32 + serverRowCount*18;
	serverItemWidget[2].hOffset      = 70;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[2].onMultiClick = openSteamURL;
  }
  
  serverItemWidget[3]              = new Text();
	serverItemWidget[3].window       = lgsl;
	serverItemWidget[3].data         = serverItem.name;
  serverItemWidget[3].color        = textColor;
  serverItemWidget[3].style        = "bold";
	serverItemWidget[3].size         = 12;
	serverItemWidget[3].opacity      = 255;
	serverItemWidget[3].vOffset      = 32 + serverRowCount*18;
	serverItemWidget[3].hOffset      = 10 + serverItemWidget[2].hOffset + serverItemWidget[2].width;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[3].onMultiClick = openSteamURL;
  }
  
  serverItemWidget[4]              = new Text();
	serverItemWidget[4].window       = lgsl;
	serverItemWidget[4].data         = serverItem.map;
  serverItemWidget[4].color        = textColor;
  serverItemWidget[4].style        = "bold";
	serverItemWidget[4].size         = 12;
	serverItemWidget[4].opacity      = 255;
	serverItemWidget[4].vOffset      = 32 + serverRowCount*18;
	serverItemWidget[4].hOffset      = 10 + serverItemWidget[3].hOffset + serverItemWidget[3].width;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[4].onMultiClick = openSteamURL;
  }
  if (serverItemWidget[4].hOffset > maxMapOffset) {
    maxMapOffset = serverItemWidget[4].hOffset;
  }

  serverItemWidget[5]              = new Text();
	serverItemWidget[5].window       = lgsl;
	serverItemWidget[5].data         = serverItem.players;
  serverItemWidget[5].color        = textColor;
  serverItemWidget[5].style        = "bold";
	serverItemWidget[5].size         = 12;
	serverItemWidget[5].opacity      = 255;
	serverItemWidget[5].vOffset      = 32 + serverRowCount*18;
	serverItemWidget[5].hOffset      = 10 + serverItemWidget[4].hOffset + serverItemWidget[4].width;
  if ( (serverItem.status.indexOf("server_online") > -1) && (serverItem.game.indexOf("halflife") > -1) ) { 
    serverItemWidget[5].onMultiClick = openSteamURL;
  }
  
  return serverItemWidget;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Update widget
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function updateServerItemWidget(serverItem, i){
	serverItemWidgets[i][0].src     = "Resources/" + serverItem.status;
	serverItemWidgets[i][1].src     = "Resources/" + serverItem.game;
	serverItemWidgets[i][2].data    = serverItem.address;
	serverItemWidgets[i][3].data    = serverItem.name;
	serverItemWidgets[i][4].data    = serverItem.map;
	serverItemWidgets[i][4].hOffset = 10 + serverItemWidgets[i][3].hOffset + serverItemWidgets[i][3].width;
	serverItemWidgets[i][5].data    = serverItem.players;
	serverItemWidgets[i][5].hOffset = 10 + serverItemWidgets[i][4].hOffset + serverItemWidgets[i][4].width;

  if (serverItemWidgets[i][4].hOffset > maxMapOffset) {
    maxMapOffset = serverItemWidgets[i][4].hOffset;
  }

}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Resize widget
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function resize() {
  lgsl.width = maxRowWidth + 25;
  
	title_center_background.width    = lgsl.width - (title_right_background.width + title_left_background.width);
	title_center_glass.width         = title_center_background.width;
	title_right_background.hOffset   = lgsl.width - title_right_background.width;
	title_right_glass.hOffset        = title_right_background.hOffset;
	center_left_background.height    = lgsl.height - (title_left_background.height + bottom_left_background.height);
	center_left_glass.height         = center_left_background.height;
	center_center_background.width   = lgsl.width - (center_right_background.width + center_left_background.width);
	center_center_glass.width        = center_center_background.width;
	center_center_background.height  = lgsl.height - (title_center_background.height + bottom_center_background.height);
	center_center_glass.height       = center_center_background.height;
	center_right_background.hOffset  = lgsl.width - center_right_background.width;
	center_right_glass.hOffset       = center_right_background.hOffset;
	center_right_background.height   = lgsl.height - (title_right_background.height + bottom_right_background.height);
	center_right_glass.height        = center_right_background.height;
	bottom_left_background.vOffset   = lgsl.height - bottom_left_background.height;
	bottom_left_glass.vOffset        = bottom_left_background.vOffset;
	bottom_center_background.vOffset = lgsl.height - bottom_center_background.height;
	bottom_center_glass.vOffset      = bottom_center_background.vOffset;
	bottom_center_background.width   = lgsl.width - (bottom_right_background.width + bottom_left_background.width);
	bottom_center_glass.width        = bottom_center_background.width;
	bottom_right_background.hOffset  = lgsl.width - bottom_right_background.width;
	bottom_right_glass.hOffset       = bottom_right_background.hOffset ;
	bottom_right_background.vOffset  = lgsl.height - bottom_right_background.height;
	bottom_right_glass.vOffset       = bottom_right_background.vOffset;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// Create serverItem's list from Status Page
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function getServerItemsFromLGSLPage(indexPage){
  var index = 0;
  var i = 0;
  var serverItemList = new Array();

  while(indexPage.indexOf(LGSL_ENTRY_START, index) > 0 ){
    var serverItem = new ServerItem();
    
    index = getReadIndex(indexPage, index, LGSL_ENTRY_START);
    index = getReadIndex(indexPage, index, LGSL_IMAGE_START);
    serverItem.status = fixImagePath(indexPage.substring(index,indexPage.indexOf(LGSL_IMAGE_STOP,index)));

    index = getReadIndex(indexPage,index,LGSL_ENTRY_START);
    index = getReadIndex(indexPage, index, LGSL_IMAGE_START);
    serverItem.game = fixImagePath(indexPage.substring(index,indexPage.indexOf(LGSL_IMAGE_STOP,index)));

    index = getReadIndex(indexPage,index,LGSL_ENTRY_START);
    index = getReadIndex(indexPage,index,LGSL_ADDRESS_START);
    serverItem.address = indexPage.substring(index,indexPage.indexOf(LGSL_ADDRESS_STOP,index));

    index = getReadIndex(indexPage,index,LGSL_ENTRY_START);
    index = getReadIndex(indexPage,index,LGSL_NAME_START);
    serverItem.name = indexPage.substring(index,indexPage.indexOf(LGSL_NAME_STOP,index));

    index = getReadIndex(indexPage,index,LGSL_ENTRY_START);
    serverItem.map = indexPage.substring(index,indexPage.indexOf(LGSL_ENTRY_STOP,index));

    index = getReadIndex(indexPage,index,LGSL_PLAYERS_START1);
    index = getReadIndex(indexPage,index,LGSL_PLAYERS_START2);
    index = getReadIndex(indexPage,index,LGSL_PLAYERS_START2);
    serverItem.players = indexPage.substring(index,indexPage.indexOf(LGSL_PLAYERS_STOP,index));

    serverItemList[i] = serverItem;

    // Prepare for next turn in the loop
    i++;
  }

  return serverItemList;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// getReadIndex
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function getReadIndex(text, index, readName){
  return text.indexOf(readName,index)+readName.length;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
// ServerItem Object;
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
function ServerItem(){
  var address;
  var game;
  var map;
  var name;
  var players;
  var status;
}
//*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

